#include "../wj_lidar/fence_controller.h"
// #include <pcl/visualization/cloud_viewer.h>
#include <fstream>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdint.h>

#include <stdio.h>
#include <string.h>
#include <unistd.h>

void save_cloud_txt(std::string txt, pcl::PointCloud<pcl::PointXYZ>::Ptr pCloud)
{
    std::ofstream os;
    os.open(txt, std::ios::out);
    for (int i = 0; i < pCloud->points.size(); i++)
    {
        pcl::PointXYZ point = pCloud->points[i];
        char buf[255];
        memset(buf, 0, 255);
        sprintf(buf, "%f %f %f\n", point.x, point.y, point.z);
        os.write(buf, strlen(buf));
    }
    os.close();
}

bool ReadProtoParam(std::string path, wj::wjLidarParams &params)
{
    int fd = open(path.c_str(), O_RDONLY);
    if (fd == -1)
        return false;
    FileInputStream *input = new FileInputStream(fd);
    bool success = google::protobuf::TextFormat::Parse(input, &params);
    // std::cout<<m_global_param.data_path()<<std::endl;
    delete input;
    close(fd);
    return success;
}

bool ReadProtoParam(std::string path, wj::wjManagerParams &params)
{
    int fd = open(path.c_str(), O_RDONLY);
    if (fd == -1)
        return false;
    FileInputStream *input = new FileInputStream(fd);
    bool success = google::protobuf::TextFormat::Parse(input, &params);
    // std::cout<<m_global_param.data_path()<<std::endl;
    delete input;
    close(fd);
    return success;
}

void fence_controller_test(int count)
{
    wj::wjManagerParams params;
    bool result = ReadProtoParam("../src/test/wj_manager_settings.prototxt", params);
    // LOG(INFO) << "读配置结果" << result;
    Fence_controller *fc = new Fence_controller();
    Error_manager code = fc->initialize(params);
    int temp = count;
    while(temp-->0){
        code = fc->get_current_status();
        // LOG(INFO) << "status: " << code.to_string();

        // pcl::PointCloud<pcl::PointXYZ>::Ptr cloud = pcl::PointCloud<pcl::PointXYZ>::Ptr(new pcl::PointCloud<pcl::PointXYZ>);
        // code = fc->get_cloud(cloud);
        // LOG(INFO) << "get cloud: " << code.to_string() << ", " << cloud->size();
        usleep(1 * 1000);
    }
}

int main(int argc, char *argv[])
{
    fence_controller_test(3);

    LOG(INFO) << "end";
    getchar();
    return 0;
}