//
// Created by zx on 2020/1/10.
//

#ifndef VERIFY_RESULT_H
#define VERIFY_RESULT_H
#include "hardware_limit.pb.h"
#include "Railing.h"

/*
 * 硬件限制检验
 * 包括旋转矩形是否会碰撞栏杆,旋转矩形中心是否在plc运动范围内
 */
class Verify_result
{
public:
    /*
     * 构造函数
     * parameter:硬件限制配置参数
     */
    Verify_result(Hardware_limit::Hardware_parameter parameter);
    /*
     * 检验硬件限制
     * rotate_rect:待检验的旋转矩形
     * height:输入高度
     * center_only:只检验中心点,不检验顶角
     */
    Error_manager verify(cv::RotatedRect rotate_rect,float height,bool verify_vertex=true);

private:
    Hardware_limit::Hardware_parameter          m_hardware_parameter;
};


#endif //VERIFY_RESULT_H
